function M = mass_matrix_voronoi(mesh)
X = mesh.vertices; T = mesh.triangles;
nv = mesh.nv;

L1 = normv(X(T(:,2),:)-X(T(:,3),:));
L2 = normv(X(T(:,1),:)-X(T(:,3),:));
L3 = normv(X(T(:,1),:)-X(T(:,2),:));
A1 = (L2.^2 + L3.^2 - L1.^2) ./ (2.*L2.*L3);
A2 = (L1.^2 + L3.^2 - L2.^2) ./ (2.*L1.*L3);
A3 = (L1.^2 + L2.^2 - L3.^2) ./ (2.*L1.*L2);
A = [A1,A2,A3];
A = acos(A);
EL = [L1, L2, L3];

ar = (1/8)*cot(A).*EL.^2;
I = [T(:,1);T(:,2);T(:,3)];
J = [T(:,2);T(:,3);T(:,1)];
S = [ar(:,3);ar(:,1);ar(:,2)];
In = [I;J];
Jn = In;
Sn = [S;S];
M = sparse(In,Jn,Sn,nv,nv); 
